var $ = jQuery;
$(function() {
    var def_input_border_color = '#d7d7d7';
    var subjectSelectObj = $('select.SelectSubject');
    var subjectInputObj = $('input.InputSubject ');
    var gradeSelectObj = $('select.SelectGrade');
    var examTypeRadio = $('input.ExamType');

    // Изменения базовых параметров дисциплины
    $(".AddDiscipline").click(function()
    {
        var errCount = 0;
        var thisObj = $(this);
        $(this).attr("disabled", true);
        var bonusRate = $(".BonusRate").prop("checked");

        var subjectID = subjectSelectObj.val();
        if (subjectID === null || subjectID === undefined || subjectID === '0') {
            subjectInputObj.css('border-color', 'red');
            errCount++;
        }

        var gradeID = parseInt(gradeSelectObj.val());
        if (gradeID <= 0 || isNaN(gradeID)) {
            gradeSelectObj.css('border-color', 'red');
            errCount++;
        }

        var examType = examTypeRadio.filter(':radio:checked').val();
        if (examType === undefined) {
            examTypeRadio.first().parent().parent().css('background-color', '#f2b4b4');
            errCount++;
        }

        if (errCount === 0)
            $.post(
                URLdir + 'handler/map/AddDiscipline',
                {
                    'Grade': gradeID,
                    'SubjectID': subjectID,
                    'BonusRate': bonusRate,
                    'ExamType': examType,
                    'LectionCount': $('input.InputLectionCount').val(),
                    'LabCount': $('input.InputLabCount').val(),
                    'PracticeCount': $('input.InputPracticeCount').val(),
                    'FacultyID': $('select.SelectFaculty').val()
                },
                function(data)
                {
                    data = $.parseJSON(data);
                    if(data.success === true) {
                        EventInspector_ShowMsg('Дисциплина добавлена', 'success');
                        setTimeout('location.replace("'+URLdir+'discipline/structure/'+data.DisciplineID+'")', 800); 
                    } else {
                        thisObj.removeAttr('disabled');
                        EventInspector_ShowMsg('Ошибка при добавлении дисциплины', 'error');
                    }
                }
            );
        else {
            thisObj.removeAttr('disabled');
            EventInspector_ShowMsg('Заполнены не все поля', 'error');
        }
    });

    subjectSelectObj.change(function(){
        if (parseInt($(this).val()) > 0)
            subjectInputObj.css('border-color', def_input_border_color);
    });

    gradeSelectObj.change(function(){
        if (parseInt($(this).val()) > 0)
            gradeSelectObj.css('border-color', def_input_border_color);
    });

    examTypeRadio.change(function(){
        var examType = $(this).val();
        if (examType == 'exam' || examType == 'credit')
            $(this).parent().parent().css('background-color', '#fff');
    });
    
    // В inputs часы (практ., лекц., лаб.) писать можно только цифры
    
    $('input.InputLectionCount').keydown(function(event) {
        KeyDownOnlyNumber(event);
    });
    
    $('input.InputLabCount').keydown(function(event) {
        KeyDownOnlyNumber(event);
    });
    
    $('input.InputPracticeCount').keydown(function(event) {
        KeyDownOnlyNumber(event);
    });
    
});