var $ = jQuery;
$(function() { 
    var g_tdClass = [];
    var g_isFocusCell = false; // Стоит фокус или нет
    var g_oldRateCell = null;
    var g_submoduleID = null;
    var g_studentID = null;
    var g_submoduleTitle = "";
    var g_stdName = "";

    // Ставим подстветку
    function TdFocus(jThis, thisClass){
        g_tdClass = thisClass.split(" ");
        g_oldRateCell = jThis.children("input").val();
        $("."+g_tdClass[0]).each(function(){
            $(this).css("background-color", "#f1f1f1");
        });
        $("."+g_tdClass[1]).each(function(){
            $(this).css("background-color", "#f1f1f1");
        });
    }
    
    // Убираем подстветку
    function TdUnFocus(){
        g_oldRateCell = null;
        $("."+g_tdClass[0]).each(function(){
            $(this).css("background-color", "#fff");
        });
        $("."+g_tdClass[1]).each(function(){
            $(this).css("background-color", "#fff");
        });
    }
    
    function TdInfo(jThis) {
        // Получаем подмодуль
        var reg = /col_\d+/;
        var tmp1 = ""+reg.exec(jThis.attr("class"));
        g_submoduleID = parseInt($(".RatingTableSubmodulesHeadMaxRate ."+tmp1+":first").attr("id"));
        g_submoduleTitle = $(".RatingTableSubmodulesHead ."+tmp1+":first").text();

        // Получаем студента
        reg = /row_\d+/;
        var tmp2 = ""+reg.exec(jThis.attr("class"));
        g_studentID = parseInt($("."+tmp2+":first").attr("id"));
        g_stdName = $("."+tmp2+":first").text();

        jThis.append("<td class='tdInfo'>"+g_submoduleTitle+"<br>"+g_stdName+"</td>");
    }

    function UnsetTdInfo(jThis){
        jThis.children(".tdInfo").remove();
        g_submoduleID = null;
        g_studentID = null;
    }

    function Rating(jThis, oldRate) {
        oldRate = parseInt(oldRate);
        // Здесь jThis - div rateCell, а не input, который является дочкой
        jThis.children("input").attr("disabled", true);

        var newRate = 0;
        if (jThis.children("input").val() !== "")
            newRate = parseInt(jThis.children("input").val());
        var maxRate = parseInt($(".RatingTableSubmodulesHeadMaxRate .col_"+g_submoduleID+":first").children("input").val());

        if (newRate <= maxRate) 
        {
            $.post(
                URLdir + "handler/rating/setRate",
                {   
                    "student": g_studentID,
                    "submodule": g_submoduleID,
                    "rate": newRate
                },
                function(data){
                    data = $.parseJSON(data);
                    if(data.success === true) {
                        jThis.siblings(".RateResult").text(parseInt(jThis.siblings(".RateResult").text()) - oldRate + newRate);
                        EventInspector_ShowMsg("Балл добавлен/изменен", "success");
                    }
                    else EventInspector_ShowMsg("Не удалось добавить/изменить балл", "error");
                    jThis.children("input").removeAttr("disabled");
                }
            );
        } 
        else {
            if (oldRate <= maxRate)
                jThis.children("input").val(oldRate);
            else
                jThis.children("input").val("0");
            EventInspector_ShowMsg("Текущий балл превышает максимальный для данного модуля", "error");
            jThis.children("input").removeAttr("disabled");
        }
    }
    
    $(".rateCell").mouseenter(function(){
        if (g_isFocusCell === false)
            TdFocus($(this), $(this).attr("class"));
    });
    
    $(".rateCell").mouseleave(function(){
        if (g_isFocusCell === false)
            TdUnFocus($(this));
    });
    
    var oldRate = 0;
    $(".rateCell").focusin(function(){
        TdInfo($(this));
        g_isFocusCell = true;
        TdFocus($(this), $(this).attr("class"));
        if ($(this).children("input").val() !== "")
            oldRate = $(this).children("input").val();
        else oldRate = 0;
    });
    
    $(".rateCell").focusout(function(){
        g_isFocusCell = false;
        var newRate = 0;
        if ($(this).children("input").val() !== "")
            newRate = $(this).children("input").val();
        if (newRate != oldRate)
            Rating($(this), oldRate);
        TdUnFocus($(this));
        UnsetTdInfo($(this));
    });
    
    $(".rateCell").keyup(function(e){
        
        var jThis = $(this);
        // Получаем подмодуль
        var reg = /col_\d+/;
        var col = ""+reg.exec(jThis.attr("class"));
        col = col.replace("col_", "");
        col = parseInt(col);
        
        // Получаем студента
        reg = /row_\d+/;
        var row = ""+reg.exec(jThis.attr("class"));
        row = row.replace("row_", "");
        row = parseInt(row);
        
        
        // При нажатие Enter (переход к оцениванию след. студента, т.е. ниже)
        if(e.keyCode==13)
        {   
            row = row + 1;
            $(".row_" + row + ".col_" + col + ".rateCell").children("input").focus();
        }

        // Стрелка вверх
        if(e.keyCode==38)
        {
            row = row - 1;
            $(".row_" + row + ".col_" + col + ".rateCell").children("input").focus();
        }
        
        // Стрелка вправо
        if(e.keyCode==39)
        {
            col = col + 1;
            $(".row_" + row + ".col_" + col + ".rateCell").children("input").focus();
        }
        
        // Стрелка вниз
        if(e.keyCode==40)
        {
            row = row + 1;
            $(".row_" + row + ".col_" + col + ".rateCell").children("input").focus();
        }
        
        // Стрелка влево
        if(e.keyCode==37)
        {
            col = col - 1;
            $(".row_" + row + ".col_" + col + ".rateCell").children("input").focus();
        }
    });
    
    $(".rateCell input").focusin(function(){
        $(this).select();
    });
    
    // При нажатие на элемент rateCell дочерный input получает фокус
    $(".rateCell ").click(function(){
        $(this).children("input").focus();
    } );
    
    // В inputCredit (где баллы вводить) разрешаем вводить только цифры
    $(".rateCell").children("input").keydown(function(event) {
        KeyDownOnlyNumber(event);
    });
    
});
